<?php

namespace Drupal\Tests\mailjet_campaign\Functional;

use Drupal\Tests\BrowserTestBase;

/**
 * Tests core campaign functionality.
 *
 * @group mailjet
 */
class MailjetCampaignTest extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['mailjet', 'mailjet_campaign'];

  /**
   * Tests retrieval of a specific campaign.
   */
  public function testGetCampaign(): void {
    $campaign_data = [
      'name' => 'Test campaign',
      'camp_id_mailjet' => '1111112e1',
    ];

    $campaign = \Drupal::service('entity_type.manager')
      ->getStorage('campaign_entity')
      ->create($campaign_data);
    $campaign->save();

    $query = \Drupal::database()->select('mailjet_campign', 'mj');
    $query->addField('mj', 'campaign_id');
    $query->condition('mj.camp_id_mailjet', $campaign_data['camp_id_mailjet']);
    $query->range(0, 1);
    $id = $query->execute()->fetchField();

    $campaign = \Drupal::service('entity_type.manager')->getStorage('campaign_entity')->load($id);
    $this->assertIsObject($campaign, 'Tested retrieval of campaign data.');

    $this->assertEquals($campaign_data['camp_id_mailjet'], $campaign->get('camp_id_mailjet')->value);
    $this->assertEquals($campaign_data['name'], $campaign->get('name')->value);
  }

}
