<?php

namespace Drupal\mailjet_event\Controller;

use Drupal\Core\Controller\ControllerBase;

/**
 * Module callback Controller.
 */
class EventCallbackController extends ControllerBase {

  /**
   * Callback for uninstall the module.
   */
  public function callback() {
    $build = [];

    // No Event sent.
    if ($_SERVER['REQUEST_METHOD'] !== 'POST') {
      print 'No data';
      return $build;
    }

    $post = trim(file_get_contents('php://input'));

    $this->getLogger('mailjet')->notice(print_r($post, TRUE));

    $event = json_decode($post);

    // No information sent with the Event.
    if (!is_object($event) && !isset($event)) {
      $this->getLogger('mailjet_event')
        ->error('No Informations sent with the Event.');

    }

    if (isset($event->email)) {
      $mail_user = user_load_by_mail($event->email);

      if (empty($mail_user)) {
        print 'No information for user with email: ' . $event->email;
      }

    }
    elseif (isset($event->original_address)) {
      $mail_user = user_load_by_mail($event->original_address);

      if (empty($mail_user)) {
        print 'No information for user with email: ' . $event->original_address;
      }
    }

    if (!empty($mail_user)) {

      $entities = $this->entityTypeManager()
        ->getStorage('mailjet_event')
        ->loadByProperties(['uid' => $mail_user->id()]);
      if (!empty($entities)) {
        foreach ($entities as $entity) {
          $entity->delete();
        }
      }

      $event_data = [
        'event_field' => serialize($event),
        'event_type' => $event->event,
      ];

      $mailjet_event_entity = $this->entityTypeManager()
        ->getStorage('mailjet_event')
        ->create($event_data)
        ->setOwnerId($mail_user->id());

      if ($mailjet_event_entity->save() === TRUE) {
        print 'Event is saved!';
      }

      else {
        print 'Error! Try again to save your event!';
      }
    }

    return $build;
  }

}
