<?php

namespace Drupal\mailjet_event\Event;

use Symfony\Component\EventDispatcher\GenericEvent;

/**
 * Block event is created for Mailjet event module.
 */
class BlockedEvent extends GenericEvent {

  /**
   * Event name.
   */
  const EVENT_NAME = 'blocked_event';

  /**
   * Submit ID.
   */
  const SUBMIT = 'event.submit';

  /**
   * Variable for Event.
   *
   * @var mixed
   */
  protected $eventVar;

  /**
   * {@inheritdoc}
   */
  public function __construct($event_var) {
    $this->eventVar = $event_var;
  }

  /**
   * Get Event.
   */
  public function getBlockedEvent() {
    return $this->eventVar;
  }

}
